proj.home <- "/home/usr0/z41440a/afghanistan_ecma_final/"

COUNTRY <- "Pakistan"

if(COUNTRY == "Afghanistan") {
    ifname <- paste(proj.home, "af_cluster_save.RData", sep="")
    load(ifname)
    ifname <- paste(proj.home, "af_cluster_save_global.RData", sep="")
    load(ifname)
} else if(COUNTRY == "Pakistan") {
    ifname <- paste(proj.home, "pak_cluster_save.RData", sep="")
    load(ifname)
    ifname <- paste(proj.home, "pak_cluster_save_global.RData", sep="")
    load(ifname)
} else stop("bad country")

if((COUNTRY != "Pakistan") & (!BFRS.WITS))
    rownames(A.loc) <- name.to.id[rownames(A.loc)]
options(echo=TRUE)

## always start with pclust, but should we use it in the middle?
PCLUST <- TRUE  # seems to be better
CLUTO <- FALSE  # (cluto and pclust give same results)
stopifnot(PCLUST + CLUTO <= 1)
MAXITER <- 12  # default is 12, but Krishna & Murty graphs go out to 200 iterations... (100 seems worse, actually??)

if(COUNTRY == "Pakistan") {
    NGROUPS <- 5
} else NGROUPS <- 3

library("parallel")
library("skmeans")

print("cores:")
print(detectCores(logical=FALSE))
CORES <- as.numeric(Sys.getenv("PJM_VNODE_CORE"))
print(CORES)
if(is.na(CORES))
    CORES <- 3

source(paste(proj.home, "cluster_base.R", sep=""))

cl <- makeForkCluster(SK.PAR)

#### for larger k, need to try more starts...
sk1 <- my.sk(1, cl=cl, A.loc=A.loc, w=w)
sk2 <- my.sk(2, cl=cl, A.loc=A.loc, w=w)
sk3 <- my.sk(3, cl=cl, A.loc=A.loc, w=w)
if(NGROUPS == 5) {
    sk4 <- my.sk(4, cl=cl, A.loc=A.loc, w=w)
    sk5 <- my.sk(5, cl=cl, A.loc=A.loc, w=w)
    print(c(sk2$value, sk3$value, sk4$value, sk5$value))
} else print(sk2$value, sk3$value)
stopCluster(cl)

if(NGROUPS == 5) {
    skmeans.df <- data.frame(skmeans2f=sk2$cluster, skmeans3f=sk3$cluster, skmeans4f=sk4$cluster, skmeans5f=sk5$cluster)
    csvt <- c("String", rep("Integer", 4))
} else {
    skmeans.df <- data.frame(skmeans2f=sk2$cluster, skmeans3f=sk3$cluster)
    csvt <- c("String", rep("Integer", 2))
}

if(EARLY.END) {
    skfname <- paste(proj.home, fname.base, SKM.WEIGHTS, "_", TR.MIN, "_", NON.NEGATIVE.COV, "_ske_", BFRS.WITS, ".csv", sep="")
} else
    skfname <- paste(proj.home, fname.base, SKM.WEIGHTS, "_", TR.MIN, "_", NON.NEGATIVE.COV, "_skm_", BFRS.WITS, ".csv", sep="")

write.csv(skmeans.df, file=skfname)
writeLines(csvt, con=paste(skfname,"t",sep=""), sep=",")
