SK.PAR <- CORES - 1 ## should this be 27 or 13???
SK.POP <- 50  ## how big should the population be for the genetic algorithm?
##STOP.NII <- 1000 ## how many iterations should we do with no improvement in the objective before we stop? (1000 seems to be enough?)
STOP.NII <- 100

do.one.pclust <- function(k, A.loc, w)  ## m=1 gives hard partitions
    skmeans(A.loc, k=k, method="pclust", weights = w, control = list(start=as.list(sample(meths, 1)), maxchains=1))

do.one.cluto <- function(k, A.loc)
    skmeans(A.loc, k=k, method="cluto")

do.many.pclust <- function(k, num, A.loc, w)
    lapply(rep(k, num), do.one.pclust, A.loc=A.loc, w=w)

do.many.cluto <- function(k, num, A.loc)
    lapply(rep(k, num), do.one.cluto, A.loc=A.loc)

do.one <- function(start, k, A.loc, w)  ## run one instance of the "genetic" method
    skmeans(A.loc, k=k, method="genetic", weights = w, control = list(start=start, mutations=0.05, maxiter=MAXITER))

## run a whole bunch of "genetic", with sequential restarts
## stopping condition is no improvement in objective for STOP.NII interations
my.sk <- function(k, cl, A.loc, w) {
    ## try all the ways of choosing random starting values
    if(CLUTO) {
        start.l <- clusterApply(cl, rep(k, SK.PAR), do.many.cluto, num=SK.POP, A.loc=A.loc)
    } else if (PCLUST) {
        start.l <- clusterApply(cl, rep(k, SK.PAR), do.many.pclust, num=SK.POP, A.loc=A.loc, w=w)
    } else start.l <- lapply(1:SK.PAR, function(i) as.list(sample(meths, SK.POP, replace=TRUE)))
    if(k==1) return(start.l[[1]])
    iter <- 0  ## total loop iterations
    no.improvement <- 0  ## how many loop iterations since we improved the objective?
    repeat { ## parallelizable if we switch to mclapply
        sk.tmp <- clusterApply(cl, start.l, do.one, k=k, A.loc=A.loc, w=w) ## run on a bunch of different starting populations
        tmp.values <- sapply(sk.tmp, function(x) x$value)  ## how good are these runs?
        sk.best.tmp <- sk.tmp[[order(tmp.values)[1]]]  ## take the best run

        if(iter == 0 || sk.best.tmp$value < sk.best$value) { # then we found something better
            no.improvement <- 0 ## reset because we just improved things
            sk.best <- sk.best.tmp ## new best instance
        } else no.improvement <- no.improvement + 1  ## otherwise another round without improvement

        sk.best.l <- rep(list(sk.best), round(SK.POP/2))  ## set half the population to our best candidate

        if(CLUTO) {
            sk.new.l <- clusterApply(cl, rep(k, SK.PAR), do.many.cluto, num=SK.POP - length(sk.best.l), A.loc=A.loc)
        } else if(PCLUST) {
            sk.new.l <- clusterApply(cl, rep(k, SK.PAR), do.many.pclust, num=SK.POP - length(sk.best.l), A.loc=A.loc, w=w)
        } else sk.new.l <- lapply(1:SK.PAR, function(i) as.list(sample(meths, SK.POP - length(sk.best.l), replace=TRUE)))

        start.l <- lapply(sk.new.l, c, sk.best.l)

        print(c(sk.best$value, sk.best.tmp$value))  ## first value should decrease monotonically
        
        if(no.improvement >= STOP.NII)  # even 100 seems like it's too low for things that aren't actually clustered.
            break

        iter <- iter + 1
    }
    print(iter)

    return(sk.best)
}

