proj.home <- "/home/usr0/z41440a/afghanistan_ecma_final/"

ifname <- paste(proj.home, "globalterrorismdb_0617dist.RData", sep="")
load(ifname)

gtdb.use <- gtdb[(gtdb[,"imonth"] != 0) & (gtdb[,"iday"] != 0),]
countries <- unlist(c(gtdb.use[,"country_txt"]))
names(countries) <- NULL

dates.str <- apply(as.matrix(gtdb.use[, c("iyear", "imonth", "iday")]), 1, paste, collapse="-")
library("lubridate")
adates <- ymd(dates.str)

related <- !is.na(gtdb.use[,"related", drop=FALSE])[,1]   # 13% are related
### afghanistan, 2003-2009:  5% related
### afghanistan, WITS dataset:  7.0% related
### pakistan, whole dataset:  9.6% related
### pakistan, BFRS, used period only:  12.9% related (slightly higher than above)
related.ag <- unclass(by(related, list(countries), FUN=mean))

dname <- paste(proj.home, "dispersion_FALSE_FALSE/", sep="")
dispersion.l <- list()
for(c.idx in 1:205) {
    ifname <- paste(dname, c.idx, ".RData", sep="")
    load(ifname)
    dispersion.l[[names(dis.l)]] <- dis.l[[1]]
}

dispersion.ag <- related.ag * NA
for(country in unique(countries)) {
    dispersion.ag[country] <- dispersion.l[[country]]["all"]
}

library("lattice")
pdf("overdispersion_related_new.pdf")
xyplot(dispersion.ag ~ related.ag, subset=table(countries)[names(dispersion.ag)]>10, xlab="Fraction 'related'", ylab="G(x) as fraction of total attacks")
dev.off()

