proj.home <- "/home/usr0/z41440a/afghanistan_ecma_final/"
ifname <- paste(proj.home, "Afghanistan_GTDB_new.RData", sep="")
load(ifname)

gtdb.tal <- gtdb.use[gtdb.use[,"gname"] %in% "Taliban" & !is.na(gtdb.use[,"latitude"]) & !is.na(gtdb.use[,"longitude"]),]

require("methods")
library("maptools")
library("rgdal")
dname <- paste(proj.home, "AFG_district_398", sep="")
ogrInfo(dname)
shp <- readOGR(dname, "district398", stringsAsFactors=FALSE)
shp@data[shp@data[,"DIST_34_NA"] == "Warduj\n", "DIST_34_NA"] <- "Warduj"
shp@data[shp@data[,"DIST_34_NA"] == "Zanda  Jan\n", "DIST_34_NA"] <- "Zanda  Jan"


pnts.tmp <- SpatialPoints(data.frame(gtdb.tal[,c("longitude", "latitude")]))
proj4string(pnts.tmp) <- proj4string(shp)

pts.tal <- cbind(over(pnts.tmp, shp), gtdb.tal)

tmp2 <- cbind(table(pts.tal[,"DIST_34_NA"]),
      aggregate(pts.tal[,"multiple"], by=list(pts.tal[,"DIST_34_NA"]), FUN=mean))

library(ggplot2)
pdf(paste(proj.home, "number_frac_multiple_lm.pdf", sep=""))
ggplot(tmp2, aes(x=Freq, y=x)) + scale_x_log10() +
    xlab("Number of Taliban Attacks in District (log scale)") +
        ylab("Multiple Attacks (fraction)") +
            geom_point() +
                geom_smooth(method="lm", formula=y ~ x)
dev.off()


