proj.home <- "/home/usr0/z41440a/afghanistan_ecma_final/"
ifname <- paste(proj.home, "Afghanistan_GTDB_new.RData", sep="")
load(ifname)

mu <- aggregate(gtdb.use[,"multiple"], by=list(gtdb.use[,"imonth"]), FUN=mean)

library("ggplot2")
mn.df <- data.frame(m=mu[,1], frac=mu[,2], tot=unclass(table(gtdb.use[,"imonth"])))
ofname <- paste(proj.home, "afg_simultaneous_seasonality.pdf", sep="")
pdf(ofname)
ggplot(mn.df)  + 
    geom_bar(aes(x=m, y=tot),stat="identity", fill="lightblue")+
    geom_line(aes(x=m, y=frac*8000),stat="identity", color="red") + 
        scale_y_continuous("Total Attacks", sec.axis = sec_axis(~./8000, name="Fraction Simultaneous"))+
scale_x_continuous("Month", breaks=1:12, labels=c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"))
dev.off()
