proj.home <- "/home/fas/weese/egw5/afghanistan/"
proj.tmp <- "/home/fas/weese/egw5/scratch/afghanistan/"

##BYMONTH <- TRUE
IRAQ <- FALSE
SPAIN <- FALSE
DF <- FALSE
NGROUPS <- 5


#### SKMEANS should now converge even on a single core (parallelization no longer depends on CORES)
print(DO.SKMEANS <- as.logical(as.numeric((Sys.getenv("DOSKMEANS")))))
print(DO.KMEANS <- as.logical(as.numeric((Sys.getenv("DOKMEANS")))))
print(DO.HSS <- as.logical(as.numeric((Sys.getenv("DOHSS")))))  # is this parallelized?
##DO.SPG <- FALSE   # replaced by hss
TR.MIN <- TRUE


##N.LIMIT <- 200
N.LIMIT <- 300
print(WITS <- as.logical(as.numeric((Sys.getenv("WITS")))))
print(PAKISTAN <- as.logical(as.numeric(Sys.getenv("PAKISTAN"))))
print(FLIP <- as.logical(as.numeric((Sys.getenv("FLIP")))))
print(SHUFFLEMONTHS <- as.logical(as.numeric((Sys.getenv("SHUFFLEMONTHS")))))
print(BYMONTH <- as.logical(as.numeric((Sys.getenv("BYMONTH")))))
print(WEIGHTS <- as.logical(as.numeric((Sys.getenv("WEIGHTS")))))
print(MSTART <- as.numeric(Sys.getenv("MSTART")))
print(MEND <- as.numeric(Sys.getenv("MEND")))
print(OMIT <- as.numeric(Sys.getenv("OMIT")))
SKM.WEIGHTS <- WEIGHTS


stopifnot(!is.na(WITS), !is.na(PAKISTAN), !is.na(FLIP), !is.na(SHUFFLEMONTHS), !is.na(BYMONTH), !is.na(WEIGHTS), !is.na(MSTART), !is.na(MEND), !is.na(OMIT))
##stopifnot(PAKISTAN + IRAQ <= 1)
##stopifnot(WITS || !IRAQ)  # nothing else available

JOBID <- Sys.getenv("LSB_BATCH_JID")
if(is.null(JOBID)) JOBID <- Sys.getenv("LSB_JOBID")
ARRIDX <- as.numeric(Sys.getenv("LSB_JOBINDEX"))
if(ARRIDX > 0) {
    SHUFFLE <- TRUE
} else SHUFFLE <- FALSE

library("methods")
options(echo=TRUE) #still don't understand why this works/is necessary

CORES <- as.numeric(Sys.getenv("LSB_DJOB_NUMPROC")) - 1
if(is.na(CORES) || CORES < 2) CORES <- 1
options(mc.cores=CORES)

country.str <- ifelse(PAKISTAN, "pak",
                      ifelse(IRAQ, "iraq",
                             ifelse(SPAIN, "spain", "af")))

fname.base <- paste(country.str, "_",
                    ifelse(SHUFFLE, "shuffle_", "actual_"),
                    ifelse(WEIGHTS, "weights_", "nw_"),
                    ifelse(BYMONTH, "bymonth_", "nbm_"),
                    ifelse(SHUFFLE, ifelse(FLIP, "flip_", "nflip_"), ""),
                    ifelse(SHUFFLE, ifelse(SHUFFLEMONTHS, "sm_", "nsm_"), ""),
                    ifelse(WITS, ifelse(SPAIN, "GTD", "WITS"), ifelse(PAKISTAN, "BFRS", "SIGACTS")),
                    ifelse((!WITS) && (!PAKISTAN) && DF, "_df_", "_"),
                    MSTART, "_",
                    MEND, "_",
                    ARRIDX, "_",
                    OMIT, sep="")
ifname <- paste(proj.tmp, fname.base, ".RData", sep="")
print(ifname)
load(ifname)

### zeroing out negative entries seems to work slightly better (?)
nonzero <- diag(weights.sum) > 0
Y <- apply(moments.tmp[nonzero,nonzero], 1:2, max, 0)
dim(Y)
rownames(Y)
stopifnot(rownames(Y) == colnames(Y))
if((N.LIMIT != 0) && (N.LIMIT < nrow(Y))) {
    dists.use <- names(rev(sort(diag(Y))))[1:N.LIMIT]
} else dists.use <- rownames(Y)
## save(dists.use, file=paste(proj.home, "dists_use.RData", sep=""))
##load(paste(proj.home, "dists_use.RData", sep=""))

Y <- Y[dists.use, dists.use]

N <- nrow(Y)

if(min(eigen(Y)$values) < 0)
    Y <- Y + diag(rep(abs(min(eigen(Y)$values)) + sqrt(.Machine$double.eps), N))

library("Rmosek")

if(TR.MIN) {
    mos <- list(sense="min")
    mos$iparam$MSK_IPAR_NUM_THREADS <- CORES

    mos$bardim <- c(N)

    mos$barA$i <- numeric(0)

    mos$barA$j <- rep(1, N*(N-1)/2 + N)
    mos$barA$k <- numeric(0)
    mos$barA$l <- numeric(0)
    mos$barA$v <- rep(1, N*(N-1)/2 + N)
    b <- numeric(0)

    ## constrain each entry of the off-diagonal separately...
    idx <- 1 
    for(l in 1:(N-1))
        for(k in (l+1):N) {
            mos$barA$i[idx] <- idx
            mos$barA$k[idx] <- k
            mos$barA$l[idx] <- l
            b[idx] <- 2*Y[k,l]
            idx <- idx+1
        }
    for(d in 1:N) {
        mos$barA$i[idx] <- idx
        mos$barA$k[idx] <- d
        mos$barA$l[idx] <- d
        b[idx] <- Y[d,d]
        idx <- idx+1
    }

    len <- idx - 1

    ## minimize the diagonal
    mos$barc$j <- rep(1, N)
    mos$barc$k <- 1:N
    mos$barc$l <- 1:N

    mos$barc$v <- rep(1, nrow(Y))


    mos$A <- Matrix(0, ncol=1, nrow=len, sparse=TRUE)
    mos$c <- 0

    blc <- b
    blc[N*(N-1)/2 + (1:N)] <- 0  # diagonal has only upper bound
    mos$bc <- rBind(blc=blc, buc=b)

    mos$bx <- rBind(blx=0, bux=0)  # looks like it's needed to avoid a pointless error message...

    barx <- 1.0 * bandSparse(N, k=0:(1-N), symm=TRUE)

    mos.out <- mosek(mos)
    barx@x <- mos.out$sol$itr$barx[[1]]
    rownames(barx) <- rownames(Y)
    colnames(barx) <- colnames(Y)

    offdiag.err <- Y - barx
    diag(offdiag.err) <- 0
    summary(c(as.matrix(offdiag.err)))
    sort(diag(Y - barx))

    ofname <- paste(proj.tmp, fname.base, "_eigen.RData", sep="")

    print(ofname)
    save(barx, file=ofname)
} else {
    barx <- Y
}

######## Huang, Sidiropoulos, and Swami [2014] ("Non-negative matrix factorization revisited")
K.SCREE <- 20   # go up higher than for the csv output
if(DO.HSS) {
    S <- barx
    ei <- eigen(S)
    if(all(ei$vectors[,1] > -sqrt(.Machine$double.eps))) {
        B <- t(t(ei$vectors) * sqrt(ei$values))
    } else B <- -t(t(ei$vectors) * sqrt(ei$values)) # negative helps with K=1
    hss <- function(K) {
        Q <- rbind(diag(nrow=K), matrix(0, nrow=nrow(S)-K, ncol=K))

        iter <- 0
        tr <- Inf
        while(abs(tr) > 1e-12) {
            W <- apply(B %*% Q, 1:2, max, 0)
            Q <- with(svd(t(W) %*% B), v %*% t(u))
            tr <- sum(diag(t(W) %*% (W - B %*% Q)))
##            print(tr)
            iter <- iter + 1
            if(iter > 1000000)
                stop("HSS: iteration limit")
        }
        print(sum((S - W %*% t(W))^2))
        colnames(W) <- paste("W", K, "g", 1:K, sep="")

        return(W)
    }

    ## doesn't appear to work for K=1 (drop=FALSE?)
    W.l <- lapply(1:K.SCREE, hss)
    W.share.l <- lapply(W.l, function(W) W/rowSums(W))

    hss.rss <- function(W)  # Frobenius norm on residual
        sqrt(sum((S - W %*% t(W))^2))
    rss <- c(sqrt(sum(S^2)), sapply(W.l, hss.rss))  # but we want the additional contribution of each new group...
    gap <- rss[-length(rss)] - rss[-1]

##    library("lattice")
    ## xyplot(rss ~ 0:K.SCREE)    
    ## xyplot(gap ~ 1:K.SCREE)    
    if(!SHUFFLE) {
        W.df <- data.frame(do.call("cbind", W.l[1:NGROUPS]))
        W.share.df <- data.frame(do.call("cbind", W.share.l[1:NGROUPS]))
        rownames(W.df) <- rownames(barx)
        rownames(W.share.df) <- rownames(barx)
        hssfname <- paste(proj.tmp, fname.base, "_hss.csv", sep="")
        hsssfname <- paste(proj.tmp, fname.base, "_hss_share.csv", sep="")
        write.csv(W.df, file=hssfname)
        write.csv(W.share.df, file=hsssfname)
        csvt <- c('"String"', rep('"Real"', ncol(W.df)))
        writeLines(csvt, con=paste(hssfname,"t",sep=""), sep=",")
        writeLines(csvt, con=paste(hsssfname,"t",sep=""), sep=",")
    }
    tmp <- c(sum(S^2), sapply(W.l, function(W) sum((S - W %*% t(W))^2)))
    tmp2 <- tmp[-length(tmp)] - tmp[-1]
    tmp3 <- tmp2[-length(tmp2)]/tmp2[-1]
    hssfname <- paste(proj.tmp, fname.base, "_hss.RData", sep="")
    save(S, W.l, tmp, tmp2, tmp3, file=hssfname)
}
