proj.home <- "/home/usr0/z41440a/afghanistan_ecma_final/"
sim.dir <- paste(proj.home, "appendix_G_output/", sep="")

library("parallel")
print("cores:")
print(detectCores(logical=FALSE))
CORES <- as.numeric(Sys.getenv("PJM_VNODE_CORE"))
print(CORES)
if(is.na(CORES))
    CORES <- 3
options(mc.cores=CORES-1L)
options(echo=TRUE)

library("methods")

### idea:  vary both N and the strength of the signal, and show how this matters?

J <- 4
N <- 100
Jmax <- N/2

idxs <- round(seq(from=0, to=N, length.out=J+1))
lens <- idxs[-1] - idxs[-length(idxs)]

T <- 2000
signal.var <- 0

library("Matrix")
do.one <- function(iter) {
    a <- lapply(lens, function(x) matrix(runif(x), nrow=x, ncol=1))  # need to make sure these stay the same mean...

    A <- bdiag(a)   # even slight differences here make things much more difficult?

    eps <- matrix(rnorm(J*T, sd=sqrt(signal.var)), nrow=J)

    X.tmp <- A %*% eps + matrix(rnorm(N*T), nrow=N)
    X <- as.matrix(X.tmp)

    Y <- cov(t(X), t(X))
    
    ret <- eigen(Y)$values
    return(ret)
}

library("parallel")
R <- 100000   # 10000 is "almost" good enough...
ei.v.l <- mclapply(1:R, do.one)

get.rat <-  function(ei.v)
    ei.v[-N] / ei.v[-1]

ei.rat.l <- mclapply(ei.v.l, get.rat)

library("lattice")
ei.v.m <- do.call("rbind", ei.v.l)
ei.v.mean <- apply(ei.v.m, 2, mean)
ei.v.q1 <- apply(ei.v.m, 2, quantile, probs=0.25)
ei.v.q3 <- apply(ei.v.m, 2, quantile, probs=0.75)

library("Hmisc")
ofname <- paste(sim.dir, "eigenb_", signal.var, ".pdf", sep="")
pdf(ofname)
xYplot(Cbind(ei.v.mean, ei.v.q1, ei.v.q3) ~ 1:N, cap=0, xlab="k", ylab="Eigenvalue")
dev.off()

ei.rat.m <- do.call("rbind", ei.rat.l)
ei.rat.mean <- apply(ei.rat.m, 2, mean)
ei.rat.q1 <- apply(ei.rat.m, 2, quantile, probs=0.25)
ei.rat.q3 <- apply(ei.rat.m, 2, quantile, probs=0.75)

ofname <- paste(sim.dir, "ERb_", signal.var, ".pdf", sep="")
pdf(ofname)
xYplot(Cbind(ei.rat.mean, ei.rat.q1, ei.rat.q3) ~ 1:(N-1), cap=0, xlab="k", ylab="ER")
dev.off()


J.hat <- apply(ei.rat.m[,1:Jmax], 1, which.max)
ofname <- paste(sim.dir, "Jhatb_", signal.var, ".RData", sep="")
save(J.hat, file=ofname)
