proj.home <- "/home/usr0/z41440a/afghanistan/"
proj.tmp <- "/home/usr0/z41440a/afghanistan/scratch/"

BFRS <- TRUE
NO.ETHNIC <- FALSE
NO.ASSASSINATION <- FALSE
TERRORISM.ONLY <- FALSE
SPLIT.KARACHI <- TRUE

if(BFRS) {
    fname <- paste(proj.home, "BFRS/bfrs.csv", sep="")
    pak <- read.csv(fname)
    if(NO.ETHNIC)
        pak <- pak[pak[,"Event.Type"] != "ethnic",]
    if(NO.ASSASSINATION) 
        pak <- pak[pak[,"Event"] != "assassination",]
    if(TERRORISM.ONLY)
        pak <- pak[pak[,"Event"] == "terrorism",]
} else {
    library("readstata13")
    fname <- paste(proj.home, "pakistanoriginal.dta", sep="")
    pak <- read.dta13(fname, missing.type=TRUE)
}

pak[,"District"] <- as.character(pak[,"District"])

if(SPLIT.KARACHI) {
    pak[pak[,"Tehsil"] == "Malir", "District"] <- "Malir"
    pak[pak[,"Tehsil"] == "Gadap", "District"] <- "Malir"
    pak[pak[,"Tehsil"] == "Bin Qasim", "District"] <- "Malir"
    pak[pak[,"Tehsil"] == "Korangi", "District"] <- "Malir"
    pak[pak[,"Tehsil"] == "Landhi", "District"] <- "Malir"
    pak[pak[,"Tehsil"] == "Shah Faisal", "District"] <- "Malir"

    pak[pak[,"Tehsil"] == "Kiamari", "District"] <- "Karachi west"
    pak[pak[,"Tehsil"] == "Baldia", "District"] <- "Karachi west"
    pak[pak[,"Tehsil"] == "Orangi", "District"] <- "Karachi west"
    pak[pak[,"Tehsil"] == "Site", "District"] <- "Karachi west"

    pak[pak[,"Tehsil"] == "Jamshed", "District"] <- "Karachi East"
    pak[pak[,"Tehsil"] == "Gulshan", "District"] <- "Karachi East"

    pak[pak[,"Tehsil"] == "Lyari", "District"] <- "Karachi South"
    pak[pak[,"Tehsil"] == "Saddar", "District"] <- "Karachi South"
}

library("rgdal")
dname <- paste(proj.home, "GADM", sep="/")
ogrListLayers(dname)
ogrInfo(dname, "PAK_adm3")
shp <- readOGR(dname, "PAK_adm3", stringsAsFactors=FALSE)


library("readstata13")

ifname <- paste(proj.home, "FKMS_PA_Analysis.dta", sep="")
fkms.tmp <- read.dta13(ifname)
fkms.tmp[fkms.tmp[,"district"] == "Lower Dir", "district"] <- "Dir"
fkms.tmp[fkms.tmp[,"district"] == "Upper Dir", "district"] <- "Dir"
fkms.tmp[fkms.tmp[,"district"] == "Nushki", "district"] <- "Chagai"
fkms.tmp[fkms.tmp[,"district"] == "Qambar Shahdad kot", "district"] <- "Larkana"
fkms.tmp[fkms.tmp[,"district"] == "Mandi Bahauddin", "district"] <- "Gujarat"
fkms.tmp[fkms.tmp[,"district"] == "Chiniot", "district"] <- "Jhang"
fkms.tmp2 <- aggregate(fkms.tmp[,"pop00"], by=list(fkms.tmp[,"district"]), FUN=sum)

fkms <- fkms.tmp2[,"x"]
names(fkms) <- fkms.tmp2[,"Group.1"]

names(fkms)[names(fkms) == "Jaccobabad"] <- "Jakobabad"
names(fkms)[names(fkms) == "Attock"] <- "Attok"
names(fkms)[names(fkms) == "D. G. Khan"] <- "Dera Ghazi Kha"
names(fkms)[names(fkms) == "D. I. Khan"] <- "Dera Ismail Khan"
names(fkms)[names(fkms) == "Malakand PA"] <- "Malakand P.A."
names(fkms)[names(fkms) == "Jaffarabad"] <- "Jafarabad"
names(fkms)[names(fkms) == "Batagram"] <- "Battagram"
names(fkms)[names(fkms) == "Gujranwala"] <- "Gujranwala 1"
names(fkms)[names(fkms) == "Killa Abdullah"] <- "Qilla Abdullah"
names(fkms)[names(fkms) == "Killa Saifullah"] <- "Qilla Saifullah"
names(fkms)[names(fkms) == "Mirpur Khas"] <- "Mirphurkhas"
names(fkms)[names(fkms) == "Naushahro Feroze"] <- "Naushahro Firoz"
names(fkms)[names(fkms) == "Kohlu"] <- "Kholu"
names(fkms)[names(fkms) == "Rajanpur"] <- "Rajan Pur"
names(fkms)[names(fkms) == "Leiah"] <- "Layyah"
names(fkms)[names(fkms) == "Tando Muhammad Khan"] <- "Tando M. Khan"
names(fkms)[names(fkms) == "Rahim Yar Khan"] <- "Rahimyar Khan"
names(fkms)[names(fkms) == "Nawabshah"] <- "Nawab Shah"
names(fkms)[names(fkms) == "Umer Kot"] <- "Umerkot"
names(fkms)[names(fkms) == "Karachi"] <- "Karachi Central"
names(fkms)[names(fkms) == "Narowal"] <- "Narowal 1"
names(fkms)[names(fkms) == "Tharparkar"] <- "Mithi"

n.tmp <- unique(shp@data[,"NAME_3"])

fkms["Muzaffarabad"] <- 741
fkms["Gilgit"] <- 243
fkms["Kurram"] <- 448
fkms["N. Waziristan"] <- 361
fkms["S. Waziristan"] <- 429
fkms["Khyber"] <- 547
fkms["Bajaur"] <- 595
fkms["Mohmand"] <- 600
fkms["Kotli"] <- 640
fkms["Neelum"] <- 126
fkms["Poonch"] <- 459
fkms["Bagh"] <- 351
fkms["Bhimber"] <- 343
fkms["Jhal Magsi"] <- 377
fkms["Orakzai"] <- 450
fkms["Chilas"] <- 132
fkms["Gilgit (Tribal Territory)"] <- 243
fkms["Kargil"] <- 143
fkms["Ladakh (Leh)"] <- 270
fkms["Sudhnati"] <- 278

names(fkms)[!(names(fkms) %in% n.tmp)]

n.tmp[!(n.tmp %in% names(fkms))]  # these don't have attacks in them?

fkms.df <- data.frame(fkms)
names(fkms.df) <- "pop"

fkfname <- paste(proj.home, "pak_fkms_pop.csv", sep="")
write.csv(fkms.df, file=fkfname)
csvt <- c("String", "Real")
writeLines(csvt, con=paste(fkfname,"t",sep=""), sep=",")

if(BFRS) {
    unique(pak[,"District"])
    pak[,"district.shp"] <- as.character(pak[,"District"])
} else {
    unique(pak[,"district"])
    pak[,"district.shp"] <- as.character(pak[,"district"])
}

pak[,"district.shp"][pak[,"district.shp"] == "Karachi"] <- "Karachi Central"
pak[,"district.shp"][pak[,"district.shp"] == "Jacobabad"] <- "Jakobabad"
pak[,"district.shp"][pak[,"district.shp"] == "South Waziristan"] <- "S. Waziristan"
pak[,"district.shp"][pak[,"district.shp"] == "North Waziristan"] <- "N. Waziristan"
pak[,"district.shp"][pak[,"district.shp"] == "Dera Ghazi Khan"] <- "Dera Ghazi Kha"
pak[,"district.shp"][pak[,"district.shp"] == "Kohlu"] <- "Kholu"
pak[,"district.shp"][pak[,"district.shp"] == "Killa Abdullah"] <- "Qilla Abdullah"
pak[,"district.shp"][pak[,"district.shp"] == "Jaffarabad"] <- "Jafarabad"
pak[,"district.shp"][pak[,"district.shp"] == "Attock"] <- "Attok"
pak[,"district.shp"][pak[,"district.shp"] == "Killa Saifullah"] <- "Qilla Saifullah"
pak[,"district.shp"][pak[,"district.shp"] == "Gujranwala"] <- "Gujranwala 1"
pak[,"district.shp"][pak[,"district.shp"] == "Mandi Bahauddin"] <- "Gujarat"
### the above district seems to be labelled as Gujarat in the shapefile (duplicated...)
pak[,"district.shp"][pak[,"district.shp"] == "Rajanpur"] <- "Rajan Pur"
pak[,"district.shp"][pak[,"district.shp"] == "Tharparkar"] <- "Mithi" 
pak[,"district.shp"][pak[,"district.shp"] == "Narowal"] <- "Narowal 1"

if(!BFRS) {
    pak[,"district.shp"][pak[,"district.shp"] == "Khyber\xa0"] <- "Khyber"
    pak[,"district.shp"][pak[,"district.shp"] == "Karachi West"] <- "Karachi west"
    pak[,"district.shp"][pak[,"district.shp"] == "Naushahro Feroze"] <- "Naushahro Firoz"
    pak[,"district.shp"][pak[,"district.shp"] == "muzaffargarh"] <- "Muzaffargarh"
    pak[,"district.shp"][pak[,"district.shp"] == "Rahim Yar Khan"] <- "Rahimyar Khan"
    pak[,"district.shp"][pak[,"district.shp"] == "Shaheed Benazirabad"] <- "Nawab Shah"
    pak[,"district.shp"][pak[,"district.shp"] == "Kachhi"] <- "Bolan"
} else {
    pak[,"district.shp"][pak[,"district.shp"] == "Chagi"] <- "Chagai"
    pak[,"district.shp"][pak[,"district.shp"] == "Bajour"] <- "Bajaur"

    pak[,"district.shp"][pak[,"district.shp"] == "Mirpurkhas"] <- "Mirphurkhas"
    pak[,"district.shp"][pak[,"district.shp"] == "Nawabshah"] <- "Nawab Shah"

    pak[,"district.shp"][pak[,"district.shp"] == "Lower Dir"] <- "Dir"
    pak[,"district.shp"][pak[,"district.shp"] == "Upper Dir"] <- "Dir"

    pak[,"district.shp"][pak[,"district.shp"] == "Tando Allahayar"] <- "Tando Allahyar"
    pak[,"district.shp"][pak[,"district.shp"] == "Tando Muhammad Khan"] <- "Tando M. Khan"

    pak[,"district.shp"][pak[,"district.shp"] == "Naushero Feroze"] <- "Naushahro Firoz"

    pak[,"district.shp"][pak[,"district.shp"] == "Kalatak"] <- "Disputed Area 1"
    pak[,"district.shp"][pak[,"district.shp"] == "Ghanche"] <- "Ladakh (Leh)"

    pak[,"district.shp"][pak[,"district.shp"] == "Chiniot"] <- "Sargodha"
    pak[,"district.shp"][pak[,"district.shp"] == "Diamir"] <- "Chilas"
    pak[,"district.shp"][pak[,"district.shp"] == "Ghizar"] <- "Gilgit (Tribal Territory)"
    pak[,"district.shp"][pak[,"district.shp"] == "Skardu"] <- "Kargil"
}

unique(shp@data[,"NAME_3"])
unique(pak[,"district.shp"])[which(!(unique(pak[,"district.shp"]) %in% unique(shp@data[,"NAME_3"])))]
unique(shp@data[,"NAME_3"])[which(!(unique(shp@data[,"NAME_3"]) %in% unique(pak[,"district.shp"])))]

if(BFRS) {
    pak <- pak[!(pak[,"district.shp"] %in% c("Unknown", "Noshki", "")),]
} else pak <- pak[!(pak[,"district.shp"] %in% c("None", ".", "Tribal Areas", "---")),]

if(BFRS) {
    dates.tmp <- as.Date(pak[,"Day...Start"], origin="1960-1-1")
} else {
    dates.tmp <- as.Date(pak[,"incidentdate"], format="%d-%b-%y")
}

d.mat <- matrix(0, nrow=length(unique(shp@data[,"NAME_3"])), ncol=as.integer(max(dates.tmp) - min(dates.tmp) + 1))

rownames(d.mat) <- unique(shp@data[,"NAME_3"])
colnames(d.mat) <- as.character(as.Date(as.Date(min(dates.tmp)):as.Date(max(dates.tmp)), origin="1970-01-01"))

for(i in 1:nrow(pak))
    d.mat[pak[i,"district.shp"], as.character(dates.tmp[i])] <- d.mat[pak[i,"district.shp"], as.character(dates.tmp[i])] + 1



#### graph
library("spdep")
tmp <- poly2nb(shp, queen=FALSE)
adj.mat <- nb2mat(tmp, style="B", zero.policy=TRUE)
colnames(adj.mat) <- row.names(adj.mat) <- shp@data[,"NAME_3"]

library("igraph") #ONE-BASED INDEXING
b.graph <- graph.adjacency(adj.mat, mode="undirected", diag=FALSE)
xy.tmp <- coordinates(shp)
V(b.graph)$lon <- xy.tmp[, 1]
V(b.graph)$lat <- xy.tmp[, 2]

stopifnot(is.connected(b.graph))

a.graph <- b.graph
#####

library("rgeos")
cents <- gCentroid(shp, byid=TRUE)
rownames(cents@coords) <- shp@data[,"NAME_3"]

if(BFRS) {
    if(NO.ETHNIC) {
        if(NO.ASSASSINATION) {
            fname <- paste(proj.home, "pak_new_BFRS_noeass.RData", sep="")
        } else fname <- paste(proj.home, "pak_new_BFRS_noethnic.RData", sep="")
    } else if (TERRORISM.ONLY) {
        fname <- paste(proj.home, "pak_new_BFRS_terror.RData", sep="")
    } else if (SPLIT.KARACHI) {
        fname <- paste(proj.home, "pak_new_BFRS_split.RData", sep="")
    } else fname <- paste(proj.home, "pak_new_BFRS.RData", sep="")
} else fname <- paste(proj.home, "pak_new_WITS.RData", sep="")
save(d.mat, a.graph, cents, file=fname)

