proj.home <- "/home/usr0/z41440a/afghanistan_ecma_final/"

options(echo=TRUE)

tmp.args <- commandArgs(trailingOnly=TRUE)
print(paste("called with args", paste(tmp.args, collapse=",")))
stopifnot(length(tmp.args) == 2)
BY.YEAR <- as.logical(as.numeric(tmp.args[1]))
C.IDX <- as.numeric(tmp.args[2])


#####
##### Global Terrorism Database
#####

##library("readxl")
##origins <- data.frame(read_excel("Data_Origins of Terrorism.xlsx"))
##tmp <- read_excel("globalterrorismdb_0616dist.xlsx", guess_max=100000)
##gtdb <- tmp
##save(gtdb, file="globalterrorismdb_0616dist.RData")
ifname <- paste(proj.home, "globalterrorismdb_0617dist.RData", sep="")
load(ifname)

GTDB.SHORT <- FALSE
gtdb.use <- gtdb[(gtdb[,"imonth"] != 0) & (gtdb[,"iday"] != 0),]


dates.str <- apply(as.matrix(gtdb.use[, c("iyear", "imonth", "iday")]), 1, paste, collapse="-")
library("lubridate")
adates <- ymd(dates.str)

countries <- unlist(c(gtdb.use[,"country_txt"]))
names(countries) <- NULL

##all.dates <- as.Date(ymd("1970-01-01"):ymd("2015-12-31"), origin="1970-01-01")
if(GTDB.SHORT) {
    all.dates <- as.Date(ymd("2001-01-01"):ymd("2016-12-31"), origin="1970-01-01")
} else
    all.dates <- as.Date(ymd("1970-01-01"):ymd("2016-12-31"), origin="1970-01-01")
n.base <- rep(0, length(all.dates))
names(n.base) <- all.dates
y.u <- year(all.dates)
m <- month(all.dates)
mnth.u <- substr(all.dates, start=1, stop=7)


dis.l <- list()
countries.use <- unique(countries)
boot <- FALSE
country <- unique(countries)[C.IDX]

n.u <- n.base
attacks.tmp <- table(adates[countries == country])
attacks <- attacks.tmp[names(attacks.tmp) %in% names(n.u)]
n.u[names(attacks)] <- attacks

if(boot) {
    set.seed(runif(1)*100000 + boot)
    n <- sample(n.u, length(n.u), replace=TRUE)
    y <- as.numeric(substr(names(n), start=1, stop=4))
    mnth <- substr(names(n), start=1, stop=7)
} else {
    n <- n.u
    y <- y.u
    mnth <- mnth.u
}

attack.months <- sort(unique(substr(names(n), start=1, stop=7)))
year.substr <- substr(names(n), start=1, stop=4)

if(BY.YEAR) {
    attack.years <- sort(unique(year.substr))
} else attack.years <- "all"

if(length(attack.months) > 1) {
    reg.out <- glm(n ~ factor(mnth) - 1, family="quasipoisson", subset=mnth %in% attack.months)
} else
    reg.out <- glm(n ~ 1, family="quasipoisson", subset=mnth %in% attack.months)

ofname <- paste(proj.home, "dispersion_", BY.YEAR, "_", GTDB.SHORT, "/", "glm_", C.IDX, ".RData", sep="")
save(reg.out, C.IDX, BY.YEAR, GTDB.SHORT, file=ofname)

