proj.home <- "/home/usr0/z41440a/afghanistan_ecma_final/"

ifname <- paste(proj.home, "Afghanistan_GTDB_new.RData", sep="")
load(ifname)

pval.vec <- rep(NA, 124)
for(i in 26:99) {
    load(paste(proj.home, "Afghanistan_", i, "_25.RData", sep=""))
    pval.vec[i] <- pval
}

adates.use <- adates
adates.use[is.na(pval.vec)] <- NA

library("lattice")
##xyplot(pval.vec ~ 1:124)
pdf("gtdb_pvals.pdf")
xyplot(pval.vec ~ adates.use, xlab="Date", ylab="p value")
dev.off()
pdf("gtdb_pvals_bw.pdf")
xyplot(pval.vec ~ adates.use, xlab="Date", ylab="p value", col="black")
dev.off()



####### Afghanistan, attributed to Taliban

fnames <- list.files(proj.home, "Afghanistan_.*_25_talattr.RData")
idx <- as.numeric(gsub("Afghanistan_(.*)_25_talattr.RData", "\\1", fnames))
pval.vec <- rep(NA, length(idx))
for(i in 1:length(idx)) {
    load(paste("Afghanistan_", idx[i], "_25_talattr.RData", sep=""))
    pval.vec[i] <- pval
}

adates.use <- adates[c(-(1:25), -(length(adates):(length(adates)-24)))]
pdf("gtdb_pvals_Afghanistan_talattr.pdf")
xyplot(pval.vec ~ adates.use, xlab="Date", ylab="p value", ylim=c(-.05,0.20))
dev.off()


####### Pakistan

ifname <- paste(proj.home, "Pakistan_GTDB_new.RData", sep="")
load(ifname)

fnames <- list.files(proj.home, "Pakistan_.*_12.RData")
idx <- as.numeric(gsub("Pakistan_(.*)_12.RData", "\\1", fnames))
pval.vec <- rep(NA, length(idx))
for(i in 1:length(idx)) {
    load(paste("Pakistan_", idx[i], "_12.RData", sep=""))
    pval.vec[i] <- pval
}

adates.use <- adates[idx]

pdf("gtdb_pvals_Pakistan.pdf")
xyplot(pval.vec ~ adates.use, xlab="Date", ylab="p value", ylim=c(-.05,1))
dev.off()
pdf("gtdb_pvals_Pakistan_bw.pdf")
xyplot(pval.vec ~ adates.use, xlab="Date", ylab="p value", ylim=c(-.05,1), col="black")
dev.off()

