proj.home <- "/home/usr0/z41440a/afghanistan_ecma_final/"

library("rgdal")
##dname <- paste(proj.home, "GREG", sep="")
##ogrListLayers(dname)
##ogrInfo(dname, "GREG")
##eth.shp <- readOGR(dname, "GREG", stringsAsFactors=FALSE)

dname <- paste(proj.home, "GADM", sep="/")

ogrListLayers(dname)
ogrInfo(dname, "PAK_adm3")

adm.shp <- readOGR(dname, "PAK_adm3", stringsAsFactors=FALSE)


library("rgeos")
##cents <- gCentroid(adm.shp, byid=TRUE)
##tmp.out <- over(cents, eth.shp)
##save(tmp.out, file="eth_cents.RData")
load("eth_cents.RData")

tmp <- read.csv(paste(proj.home, "rep_pak_bymonth_TRUE_TRUE_TRUE_skm_BFRS_finaltest_rep_nonneg.csv", sep=""))
row.names(tmp) <- tmp[,1]
skmeans.df <- tmp[,-1]

skmeans.df[,"eth"] <- NA
skmeans.df[adm.shp@data[,"NAME_3"], "eth"] <-  tmp.out[,"G1SHORTNAM"]
skmeans.df[skmeans.df[,"eth"] %in% c("Panjabis", "Jhats, Awans"), "eth"] <- "Panjabis, Jhats, Awans"
skmeans.df[skmeans.df[,"eth"] %in% c("Gujars", "Kashmiris", "Kho", "Kohistanis", "Shina"), "eth"] <- "Other"

## Table 3
reg1 <- lm(I(skmeans4f==1) ~ eth - 1, data=skmeans.df)
reg2 <- lm(I(skmeans4f==2) ~ eth - 1, data=skmeans.df)
reg3 <- lm(I(skmeans4f==3) ~ eth - 1, data=skmeans.df)
reg4 <- lm(I(skmeans4f==4) ~ eth - 1, data=skmeans.df)

## Pearson chi-square test
pearson.dat <- skmeans.df[,c("skmeans4f", "eth")]
##chisq.test(table(pearson.dat))
fisher.test(table(pearson.dat), workspace=1e08)   # p=1e-13


library("apsrtable")
notes <- list("Dependent variable is dummy variable indicating whether district has been clustered into specified group number", se.note, stars.note)
coef.names <- substr(names(coef(reg1)), start=4, stop=nchar(names(coef(reg1))))
tab.out1 <- apsrtable(reg1,reg2,reg3,reg4, model.names=c("Group 1", "Group 2", "Group 3", "Group 4"), label="tab:pak_eth", notes=notes, coef.names=coef.names)
ofname <- paste(proj.home, "tab_pak_eth.tex", sep="")
writeLines(tab.out1, con=ofname)

tmp.csv <- read.csv(file=paste(proj.home, "pak_TRUE_TRUE_barx_hss_share.csv", sep=""), stringsAsFactors=FALSE)

rownames(tmp.csv) <- tmp.csv[,"X"]
spg.df <- cbind(tmp.csv[,-1], eth=NA)
spg.df[adm.shp@data[,"NAME_3"], "eth"] <-  tmp.out[,"G1SHORTNAM"]
spg.df[spg.df[,"eth"] %in% c("Panjabis", "Jhats, Awans"), "eth"] <- "Panjabis, Jhats, Awans"
spg.df[spg.df[,"eth"] %in% c("Gujars", "Kashmiris", "Kho", "Kohistanis", "Shina"), "eth"] <- "Other"

reg1 <- lm(W4g3 ~ eth - 1, data=spg.df)
reg2 <- lm(W4g2 ~ eth - 1, data=spg.df)
reg3 <- lm(W4g4 ~ eth - 1, data=spg.df)
reg4 <- lm(W4g1 ~ eth - 1, data=spg.df)

notes <- list("Dependent variable is estimated group prevalence in district", se.note, stars.note)
coef.names <- substr(names(coef(reg1)), start=4, stop=nchar(names(coef(reg1))))
tab.out2 <- apsrtable(reg1,reg2,reg3,reg4, model.names=c("Group 1", "Group 2", "Group 3", "Group 4"), label="tab:pak_eth_spg", notes=notes, coef.names=coef.names)
ofname <- paste("~/afghanistan/tab_pak_eth_spg_new.tex", sep="")
writeLines(tab.out2, con=ofname)



### Table N.9
tmp <- read.csv(paste(proj.home, "rep_pak_nbm_TRUE_TRUE_TRUE_skm_FALSE.csv", sep=""))

row.names(tmp) <- tmp[,1]
skmeanse.df <- tmp[,-1]

skmeanse.df[,"eth"] <- NA

skmeanse.df[adm.shp@data[,"NAME_3"], "eth"] <-  tmp.out[,"G1SHORTNAM"]
skmeanse.df[skmeans.df[,"eth"] %in% c("Panjabis", "Jhats, Awans"), "eth"] <- "Panjabis, Jhats, Awans"
skmeanse.df[skmeans.df[,"eth"] %in% c("Gujars", "Kashmiris", "Kho", "Kohistanis", "Shina"), "eth"] <- "Other"

dat1 <- skmeans.df[,"skmeans4f"]
names(dat1) <- rownames(skmeans.df)
dat2 <- skmeanse.df[,"skmeans4f"]
names(dat2) <- rownames(skmeanse.df)
dat <- data.frame(dat1, dat1)
dat[names(dat2),2] <- dat2
colnames(dat) <- c("d1", "d2")

reg1 <- lm(I(d2==1) ~ factor(d1) - 1, data=dat)
reg2 <- lm(I(d2==2) ~ factor(d1) - 1, data=dat)
reg3 <- lm(I(d2==3) ~ factor(d1) - 1, data=dat)
reg4 <- lm(I(d2==4) ~ factor(d1) - 1, data=dat)



