proj.home <- "/home/usr0/z41440a/afghanistan_ecma_final/"
ifname <- paste(proj.home, "Afghanistan_GTDB_16.RData", sep="")
load(ifname)

gtdb.tal <- gtdb.use[gtdb.use[,"gname"] %in% "Taliban" & !is.na(gtdb.use[,"latitude"]) & !is.na(gtdb.use[,"longitude"]),]

require("methods")
library("maptools")
library("rgdal")
##sname <- paste(proj.home, "afg_admbnd_adm3_pol", sep="")
##sname <- paste(proj.home, "AFG_district_398/district398", sep="")
##shp <- readShapePoly(sname)
dname <- paste(proj.home, "AFG_district_398", sep="")
ogrInfo(dname)
shp <- readOGR(dname, "district398", stringsAsFactors=FALSE)
shp@data[shp@data[,"DIST_34_NA"] == "Warduj\n", "DIST_34_NA"] <- "Warduj"
shp@data[shp@data[,"DIST_34_NA"] == "Zanda  Jan\n", "DIST_34_NA"] <- "Zanda  Jan"


pnts.tmp <- SpatialPoints(data.frame(gtdb.tal[,c("longitude", "latitude")]))
proj4string(pnts.tmp) <- proj4string(shp)

pts.tal <- cbind(over(pnts.tmp, shp), gtdb.tal)

tmp2 <- cbind(table(pts.tal[,"DIST_34_NA"]),
      aggregate(pts.tal[,"multiple"], by=list(pts.tal[,"DIST_34_NA"]), FUN=mean))


tot.attacks <- table(pts.tal[,"DIST_34_NA"])
tmp <- aggregate(pts.tal[,"multiple"], by=list(pts.tal[,"DIST_34_NA"]), FUN=mean)
frac.multiple <- tmp[,"x"]
names(frac.multiple) <- tmp[,"Group.1"]

pts.tal[,"tot.attacks"] <- tot.attacks[pts.tal[,"DIST_34_NA"]]

##library("splines")
##reg.out <- lm(multiple ~ tot.attacks, dat=pts.tal)
##reg.out <- lm(multiple ~ tot.attacks + I(tot.attacks^2), dat=pts.tal)
##reg.out <- lm(multiple ~ bs(log(tot.attacks), df=5), dat=pts.tal)
##xyplot(reg.out$fitted ~ pts.tal$tot.attacks)

library("readstata13")
dta <- read.dta13(paste(proj.home, "FINAL_NEWER.dta", sep=""))
##load(paste(proj.home, "dat_new.RData", sep=""))
dta[,"DIST_34_NA"] <- substr(dta[,"dist_34_na"], 2, nchar(dta[,"dist_34_na"]) - 1)
dta[,"PROV_34_NA"] <- substr(dta[,"prov_34_na"], 2, nchar(dta[,"prov_34_na"]) - 1)
##tmp[,"DIST_34_NA"] %in% pts.tal[,"DIST_34_NA"]
##unique(pts.tal[,"DIST_34_NA"])[which(!(unique(pts.tal[,"DIST_34_NA"]) %in% tmp[,"DIST_34_NA"]))]
stopifnot(pts.tal[,"DIST_34_NA"] %in% dta[,"DIST_34_NA"])
dta[,"tot.attacks"] <- tot.attacks[dta[,"DIST_34_NA"]]
dta[,"frac.multiple"] <- frac.multiple[dta[,"DIST_34_NA"]]

##reg.glm <- glm(frac.multiple ~ tot.attacks, family=binomial(link="logit"), weights=tot.attacks, data=dta)
##reg.glm <- glm(frac.multiple ~ tot.attacks + I(tot.attacks^2), family=binomial(link="logit"), weights=tot.attacks, data=dta)
##reg.glm <- glm(frac.multiple ~ tot.attacks + I(tot.attacks^2) + PROV_34_NA, family=binomial(link="logit"), weights=tot.attacks, data=dta)


##frac.reg <- lm(frac.multiple ~ tot.attacks + I(tot.attacks^2) + log(population08) + log(areadistrict) + mean_1992 + mean_2000 + mean_2012 + PROV_34_NA, data=dta)

##frac.reg <- lm(frac.multiple ~ log(tot.attacks) + I(log(tot.attacks)^2) + log(population08) + log(areadistrict) + mean_1992 + mean_2000 + mean_2012 + PROV_34_NA, data=dta)

frac.reg1 <- lm(frac.multiple ~ log(tot.attacks) + log(population08) + log(areadistrict), data=dta)
frac.reg2 <- lm(frac.multiple ~ log(tot.attacks) + log(population08) + log(areadistrict) + mean_1992 + mean_2000 + mean_2012 + PROV_34_NA, data=dta)
frac.reg3 <- glm(frac.multiple ~ log(tot.attacks) + log(population08) + log(areadistrict), family=binomial(link="logit"), weights=tot.attacks, data=dta)
frac.reg4 <- glm(frac.multiple ~ log(tot.attacks) + log(population08) + log(areadistrict) + mean_1992 + mean_2000 + mean_2012 + PROV_34_NA, family=binomial(link="logit"), weights=tot.attacks, data=dta)

library("stargazer")
ofname <- paste(proj.home, "tab_frac.tex", sep="")
stargazer(frac.reg1, frac.reg2, frac.reg3, frac.reg4, omit=c("mean", "PROV"), float=FALSE, out=ofname)

