proj.home <- "/home/usr0/z41440a/afghanistan_ecma_final/"

fname <- paste(proj.home, "/globalterrorismdb_0616dist.RData", sep="")
##fname <- paste(proj.home, "/globalterrorismdb_0617dist.RData", sep="")
load(fname)

gtdb98 <- gtdb[gtdb[,"iyear"] >= 1998,]
####### show that multiple attacks are more often claimed

gtdb98[!(gtdb98$claimed %in% c(0,1)),"claimed"] <- NA  # -9, 2
table(gtdb98$claimed)
gtdb98[gtdb98$nperps %in% c(-99, -9, 0), "nperps"] <- NA 
reg.out <- lm(claimed ~ multiple, data=gtdb98)
reg.out <- lm(claimed ~ multiple + country_txt - 1, data=gtdb98)
reg.out <- lm(claimed ~ multiple + country_txt - 1, data=gtdb98, subset=gtdb98$success==0)  # still there
reg.out <- lm(claimed ~ multiple + nperps + country_txt - 1, data=gtdb98)
reg.out <- lm(claimed ~ multiple + nperps + log(nperps) + country_txt - 1, data=gtdb98)

gtdb98$nperps.tot <- gtdb98$nperps
gtdb98$nkill.tot <- gtdb98$nkill
gtdb98$nwound.tot <- gtdb98$nwound
## gtdb98$propvalue.tot <- gtdb98$propvalue  # almost no data
for(i in 1:nrow(gtdb98))  # 20 mins
    if(gtdb98[i,"multiple"] == 1) {
        rel.str <- strsplit(gtdb98$related[i], split=", ")[[1]]
        related <- gtdb98$eventid %in% rel.str        
        gtdb98$nperps.tot[i] <- sum(gtdb98[related,"nperps"]) + gtdb98[i, "nperps"]
        gtdb98$nkill.tot[i] <- sum(gtdb98[related,"nkill"]) + gtdb98[i, "nkill"]
        gtdb98$nwound.tot[i] <- sum(gtdb98[related,"nwound"]) + gtdb98[i, "nwound"]
#        gtdb98$propvalue.tot[i] <- sum(gtdb98[related,"propvalue"]) + gtdb98[i, "propvalue"]
    }
##gtdb98[,"nperps.tot"] <- gtdb98[,"nperps.tot"] + gtdb98[,"nperps"]


### TABLE N.4
###### assassinations should be less likely to be part of multiple attacks

type.reg1 <- lm(multiple ~ attacktype1_txt - 1, data=gtdb98)
##reg1 <- lm(multiple ~ attacktype1_txt + log(nperps.tot) - 1, data=gtdb98)         # positive coefficient is unsurprising, so use nperps
type.reg2 <- lm(multiple ~ attacktype1_txt + log(nperps) + log(nkill+1) + log(nwound+1) + country_txt - 1, data=gtdb98)
## reg1 <- lm(multiple ~ attacktype1_txt + log(nperps) + log(nkill+1) + log(nwound+1) + gname - 1, data=gtdb98)  # doesn't work
type.reg3 <- glm(multiple ~ attacktype1_txt - 1, data=gtdb98, family=binomial)
type.reg4 <- glm(multiple ~ attacktype1_txt + log(nperps) + log(nkill+1) + log(nwound+1) + country_txt - 1, data=gtdb98, family=binomial)
##reg <- glm(multiple ~ attacktype1_txt + log(nperps) + log(nkill+1) + log(nwound+1) + country_txt + gname - 1, data=gtdb98, family=binomial)  # doesn't converge

library("stargazer")
ofname <- paste(proj.home, "tab_type.tex", sep="")
stargazer(type.reg1, type.reg2, type.reg3, type.reg4, omit=c("country_txt", "gname"), float=FALSE, out=ofname)

### TABLE N.5
claim.reg1 <- lm(claimed ~ multiple, data=gtdb98)        
claim.reg2 <- lm(claimed ~ multiple + log(nperps.tot) + log(nkill.tot+1) + log(nwound.tot+1), data=gtdb98)        
##reg.out <- lm(claimed ~ multiple + nperps.tot + log(nperps.tot) + nkill.tot + log(nkill.tot+1) + country_txt - 1, data=gtdb98)        
##reg.out <- lm(claimed ~ multiple + log(nperps.tot) + log(nkill.tot+1) + log(nwound.tot+1) + country_txt - 1, data=gtdb98) # groups are within countries (usually)
claim.reg3 <- lm(claimed ~ multiple + log(nperps.tot) + log(nkill.tot+1) + log(nwound.tot+1) + country_txt + gname - 1, data=gtdb98)

claim.reg4 <- glm(claimed ~ multiple, data=gtdb98, family=binomial)
claim.reg5 <- glm(claimed ~ multiple + log(nperps.tot) + log(nkill.tot+1) + log(nwound.tot+1), data=gtdb98, family=binomial)
##reg.out <- glm(claimed ~ multiple + log(nperps.tot) + log(nkill.tot+1) + log(nwound.tot+1) + country_txt + gname - 1, data=gtdb98, family=binomial)  # no convergence
##claim.reg6 <- glm(claimed ~ multiple + log(nperps.tot) + log(nkill.tot+1) + log(nwound.tot+1) + country_txt - 1, data=gtdb98, family=binomial)
claim.reg6 <- glm(claimed ~ multiple + log(nperps.tot) + log(nkill.tot+1) + log(nwound.tot+1) + gname - 1, data=gtdb98, family=binomial)

library("stargazer")
ofname <- paste(proj.home, "tab_claim.tex", sep="")
stargazer(claim.reg1, claim.reg2, claim.reg3, claim.reg4, claim.reg5, claim.reg6, omit=c("country_txt", "gname"), float=FALSE, out=ofname)





